%{
#include <stdio.h>
#include <string.h>
#include "y.tab.h"

extern int yylval;
%}

%%
add	return ADD;
sub	return SUB;
mul	return MUL;
div	return DIV;
sll	return SLL;
srl	return SRL;
srr	return SRR;
and	return AND;
or	return OR;
xor	return XOR;
not	return NOT;

addi	return ADDI;
subi	return SUBI;
muli	return MULI;
divi	return DIVI;
andi	return ANDI;
ori	return ORI;
xori	return XORI;

fadd	return FADD;
fsub	return FSUB;
fmul	return FMUL;
fdiv	return FDIV;
itof	return ITOF;
ftoi	return FTOI;
fabs	return FABS;
fneg	return FNEG;
floor	return FLOOR;
fsqrt	return FSQRT;

nop	return NOP;
hlt	return HLT;
rd	return RD;
wr	return WR;

load	return LOAD;
store	return STORE;
	
jump	return JUMP;
jal	return JAL;
jr	return JR;

bl	return BL;
be	return BE;
ble	return BLE;
bge	return BGE;
bne	return BNE;
bg	return BG;
blz	return BLZ;
bez	return BEZ;
blez	return BLEZ;
bgez	return BGEZ;
bnez	return BNEZ;
bgz	return BGZ;

fbl	return FBL;
fbe	return FBE;
fble	return FBLE;
fbge	return FBGE;
fbne	return FBNE;
fbg	return FBG;
fblz	return FBLZ;
fbez	return FBEZ;
fblez	return FBLEZ;
fbgez	return FBGEZ;
fbnez	return FBNEZ;
fbgz	return FBGZ;


r[0-9]+		{ yylval = atoi(yytext + 1); return REG; }

-?[0-9]+ |
0(x|X)[0-9a-fA-F]+	{ yylval = atoi(yytext); return NUM; }

\n	return NL;
[ \t]	;

#.*\n	return NL;

%%
